# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define with_bootstrap %{!?_with_bootstrap:0}%{?_with_bootstrap:1}
%define without_bootstrap %{?_with_bootstrap:0}%{!?_with_bootstrap:1}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

Summary:        Selenium Remote Control
Name:           openqa-selenium-rc
Version:        0.9.2
Release:        2%{?dist}
Epoch:          0
License:        ASL 2.0
URL:            http://www.openqa.org/selenium-rc/
Group:          Development/Testing
Source0:        selenium-rc-0.9.2.tar.gz
# svn export -r 2005 http://svn.openqa.org/svn/selenium-rc/trunk selenium-rc-0.9.2
Source1:        selenium-rc-jpp-depmap.xml
Source2:        selenium-rc-settings.xml
Source3:        selenium-rc-build.tar.gz
Patch0:         selenium-rc-forkmode.patch
Patch1:         selenium-rc-server-pom.patch
Patch2:         selenium-rc-bootstrap.patch
Patch3:         selenium-rc-pom.patch
#Patch4:         selenium-rc-server-dep.patch


BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-nodeps
BuildRequires:  ant-junit
BuildRequires:  ant-trax
BuildRequires:  junit
%if %{with_maven}
BuildRequires:  maven2 >= 2.0.4
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
%endif
BuildRequires:  bouncycastle-jdk1.5
BuildRequires:  excalibur-avalon-framework
BuildRequires:  jakarta-commons-logging
BuildRequires:  jetty5
BuildRequires:  servlet_2_4_api
BuildRequires:  subversion
%if %{without_bootstrap}
BuildRequires:  openqa-selenium-core
BuildRequires:  openqa-selenium-ide
%endif

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Selenium Remote Control is a test tool that allows you to 
write automated application UI tests in any programming 
language against any HTTP website using any mainstream 
JavaScript-enabled browser.
Selenium Remote Control provides a Selenium Server, which 
can automatically start/stop/control any supported browser.
It works by using Selenium Core, a pure-HTML+JS library that
performs automated tasks in JavaScript.

%package server-coreless
Summary:        Coreless Server Module from %{name}
Group:          Development/Testing
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description server-coreless
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{without_bootstrap}
%package server
Summary:        Server Module from %{name}
Group:          Development/Testing
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description server
%{summary}.


%package xlator
Summary:        Xlator Module from %{name}
Group:          Development/Testing
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description xlator
%{summary}.


%package java-client-driver
Summary:        Java Client Driver Module from %{name}
Group:          Development/Testing
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description java-client-driver
%{summary}.
%endif

%prep
%setup -q -n selenium-rc-%{version}
%setup -q -n selenium-rc-%{version} -T -D -a 3
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
mv server-coreless/src/main/resources/customProfileDirCUSTFFCHROME/extensions/readystate@openqa.org/chrome/readystate.jar.no \
server-coreless/src/main/resources/customProfileDirCUSTFFCHROME/extensions/readystate@openqa.org/chrome/readystate.jar
cp %{SOURCE2} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%if %{with_bootstrap}
%patch2 -b .sav2
%endif
%patch3 -b .sav3
#%patch4 -b .sav4

%build
%if %{with_maven}
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
mkdir -p $MAVEN_REPO_LOCAL/bouncycastle
ln -sf $(build-classpath bouncycastle/bcprov) $MAVEN_REPO_LOCAL/bouncycastle/bcprov-jdk15.jar
MAVEN_SETTINGS=$(pwd)/settings.xml
mvn-jpp \
        -e \
        -s $MAVEN_SETTINGS \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        ant:ant install javadoc:javadoc
mkdir standalone
rm -rf selenium-server/target/assembly/work/avalon-framework*
rm -rf selenium-server/target/assembly/work/log4j*
rm -rf selenium-server/target/assembly/work/logkit*
for d in selenium-server/target/assembly/work/*; do
cp -pr $d/* standalone
done
rm -f standalone/META-INF/BCKEY.DSA
rm -f standalone/META-INF/BCKEY.SF
echo "Manifest-Version: 1.0" > standalone/META-INF/MANIFEST.MF
echo "Main-Class: org.openqa.selenium.server.SeleniumServer" >> standalone/META-INF/MANIFEST.MF

pushd standalone
jar cmf META-INF/MANIFEST.MF ../selenium-server-standalone.jar *
popd
cp selenium-server-standalone.jar selenium-server/target/selenium-server-%{version}-standalone.jar
mkdir -p $MAVEN_REPO_LOCAL/org.openqa.selenium.server
cp selenium-server-standalone.jar $MAVEN_REPO_LOCAL/org.openqa.selenium.server/selenium-server.jar
mkdir -p $MAVEN_REPO_LOCAL/JPP
cp selenium-server-standalone.jar $MAVEN_REPO_LOCAL/JPP/selenium-server.jar
pushd clients
mvn-jpp \
        -e \
        -s $MAVEN_SETTINGS \
        -Dmaven.dependency.org.openqa.selenium.server.selenium-server.standalone.jar.path=$MAVEN_REPO_LOCAL/org.openqa.selenium.server/selenium-server.jar \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc
popd
%else
export OPT_JAR_LIST="ant/ant-nodeps ant/ant-junit junit ant/ant-trax"
export CLASSPATH=$(build-classpath \
ant \
bouncycastle/bcprov \
commons-logging \
jetty5/jetty5 \
js \
junit \
selenium-core \
selenium-ide \
servlet_2_4_api \
xalan-j2 \
xalan-j2-serializer \
)
CLASSPATH=$CLASSPATH:$(pwd)/selenium-server/target/selenium-server-%{version}.jar
CLASSPATH=$CLASSPATH:target/classes:target/test-classes
pushd server-coreless
ant -Dbuild.sysclasspath=only jar javadoc
popd
pushd selenium-server
ant -Dbuild.sysclasspath=only jar
popd
pushd xlator
ant -Dbuild.sysclasspath=only jar javadoc
popd
mkdir standalone
pushd standalone
jar xf $(build-classpath ant)
jar xf $(build-classpath bouncycastle/bcprov)
jar xf $(build-classpath commons-logging)
jar xf $(build-classpath jetty5/jetty5)
jar xf $(build-classpath junit)
jar xf $(build-classpath selenium-core)
jar xf $(build-classpath servlet_2_4_api)
jar xf ../server-coreless/target/selenium-server-coreless-%{version}.jar
jar xf ../selenium-server/target/selenium-server-%{version}.jar
rm -f META-INF/BCKEY.DSA
rm -f META-INF/BCKEY.SF
echo "Manifest-Version: 1.0" > META-INF/MANIFEST.MF
echo "Main-Class: org.openqa.selenium.server.SeleniumServer" >> META-INF/MANIFEST.MF
jar cmf META-INF/MANIFEST.MF ../selenium-server-standalone.jar *
popd
CLASSPATH=$CLASSPATH:$(pwd)/selenium-server-standalone.jar
mkdir -p clients/target
cp standalone/core/iedoc.xml clients/target
pushd clients/java
ant -f generate-sources.xml \
    -Dselenium-server=../../selenium-server-standalone.jar \
    -Dbuild.sysclasspath=only \
    ant-generate-sources ant-generate-tests
ant -Dbuild.sysclasspath=only jar javadoc
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 server-coreless/target/selenium-server-coreless-%{version}.jar \
      $RPM_BUILD_ROOT%{_javadir}/selenium-server-coreless-%{version}.jar
%if %{without_bootstrap}
install -m 644 selenium-server-standalone.jar \
      $RPM_BUILD_ROOT%{_javadir}/selenium-server-standalone-%{version}.jar
install -m 644 selenium-server/target/selenium-server-%{version}.jar \
      $RPM_BUILD_ROOT%{_javadir}/selenium-server-%{version}.jar
install -m 644 clients/java/target/selenium-java-client-driver-%{version}.jar \
      $RPM_BUILD_ROOT%{_javadir}/selenium-java-client-driver-%{version}.jar
install -m 644 xlator/target/selenium-xlator-%{version}.jar \
      $RPM_BUILD_ROOT%{_javadir}/selenium-xlator-%{version}.jar
%endif
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-selenium-rc.pom
%add_to_maven_depmap org.openqa.selenium selenium-rc %{version} JPP selenium-rc
install -m 644 server-coreless/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-selenium-server-coreless.pom
%add_to_maven_depmap org.openqa.selenium.server selenium-server-coreless %{version} JPP selenium-server-coreless
%if %{without_bootstrap}
install -m 644 selenium-server/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-selenium-server.pom
%add_to_maven_depmap org.openqa.selenium.server selenium-server %{version} JPP selenium-server
install -m 644 clients/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-selenium-client-drivers.pom
%add_to_maven_depmap org.openqa.selenium.client-drivers selenium-client-drivers %{version} JPP selenium-client-drivers
install -m 644 clients/java/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-selenium-java-client-driver.pom
%add_to_maven_depmap org.openqa.selenium.client-drivers selenium-java-client-driver %{version} JPP selenium-java-client-driver
install -m 644 xlator/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-selenium-xlator.pom
%add_to_maven_depmap org.openqa.selenium selenium-xlator %{version} JPP selenium-xlator
%endif


# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/coreless
cp -pr server-coreless/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/coreless
%if %{without_bootstrap}
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/clients
cp -pr clients/java/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/clients
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/xlator
cp -pr xlator/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/xlator
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files 
%defattr(0644,root,root,0755)
%doc license/selenium_license.txt
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files server-coreless
%defattr(0644,root,root,0755)
%{_javadir}/selenium-server-coreless*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{without_bootstrap}
%files server
%defattr(0644,root,root,0755)
%{_javadir}/selenium-server-%{version}.jar
%{_javadir}/selenium-server.jar
%{_javadir}/selenium-server-standalone*.jar

%files xlator
%defattr(0644,root,root,0755)
%{_javadir}/selenium-xlator*.jar

%files java-client-driver
%defattr(0644,root,root,0755)
%{_javadir}/selenium-java-client-driver*.jar
%endif

%changelog
* Fri Jul 18 2008 David Walluck <dwalluck@redhat.com> 0:0.9.2-2
- remove javadoc scriptlets
- update License
- update BuildRoot

* Tue Dec 04 2007 Ralph Apel <r.apel at r-apel.de> - 0:0.9.2-1jpp
- First release

